#include <stdio.h>

#define MAX_NODES 128
#define MAX_VALUE 1000000000
#define MAX_MIDDLE 5

int n, m, k, res;
int a[MAX_NODES][MAX_NODES], middle[MAX_MIDDLE], perm_middle[MAX_NODES];
bool visited[MAX_MIDDLE];

void floyd()
{
	for(int k = 1; k <= n; k++)
		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= n; j++)
				if(a[i][j] > a[i][k] + a[k][j])
					a[i][j] = a[i][k] + a[k][j];
}

void check()
{
	int curr_path = 0;

	for(int i = 0; i < k-1; i++)
		curr_path += a[middle[perm_middle[i]]][middle[perm_middle[i+1]]];
	curr_path += a[1][middle[perm_middle[0]]] + a[middle[perm_middle[k-1]]][n];

	if(curr_path < res)
		res = curr_path;
}

void perm(int index)
{
	if(index == k)
		check();
	else
	{
		for(int i = 0; i < k; i++)
			if(!visited[i])
			{
				visited[i] = true;
				perm_middle[index] = i;
				perm(index+1);
				visited[i] = false;
			}
	}
}

int main()
{
	int tests;
	scanf("%d", &tests);
	while(tests--)
	{
		scanf("%d %d %d", &n, &m, &k);

		// init matrix
		for(int i = 1; i <= n; i++)
			for(int j = 1; j <= n; j++)
				a[i][j] = MAX_VALUE;

		// read edges
		for(int i = 0; i < m; i++)
		{
			int x, y, z;
			scanf("%d %d %d", &x, &y, &z);
			if(z < a[x][y])
				a[x][y] = a[y][x] = z;
		}

		// read intermediate towns
		for(int i = 0; i < k; i++)
			scanf("%d", &middle[i]);

		// calculate shortest paths between all towns
		floyd();

		res = MAX_VALUE;
		// generate all permutations of intermediate towns and find the best one
		perm(0);

		printf("%d\n", res);
	}

	return 0;
}
